//XMLCCallbacks.h
//modified Arne Bartels	arne.bartels@t-online.de


#ifndef	XMLCCALLBACKS_H
#define	XMLCCALLBACKS_H




#define	INTERFACE_NAME				"fs9traffic"

#define	NAME_RADAR					"radar"
#define	NAME_TCAS					"tcas"

#define	NAME_RANGE					"range"
#define	NAME_BRIGHT					"brightness"
#define	NAME_XMOUSE					"mouseRelPosX"
#define	NAME_YMOUSE					"mouseRelPosY"
#define	NAME_TTIP					"toolTip"
#define	NAME_ADVISORY				"advisory"
#define	NAME_TIM_SEP_TA				"timeSeparationTA"
#define	NAME_TIM_SEP_RA				"timeSeparationRA"
#define	NAME_DST_SEP_TA				"distSeparationTA"
#define	NAME_DST_SEP_RA				"distSeparationRA"
#define	NAME_ALT_SEP_TA				"altSeparationTA"
#define	NAME_ALT_SEP_RA				"altSeparationRA"

#define	NAME_TTIP_ID				"toolTipId"
#define	NAME_TTIP_ALT				"toolTipAlt"
#define	NAME_TTIP_RADALT			"toolTipRadAlt"
#define	NAME_TTIP_DIST				"toolTipDist"
#define	NAME_TTIP_BRG				"toolTipBrg"
#define	NAME_TTIP_DELTA_ALT			"toolTipAltDiff"
#define	NAME_TTIP_TRACK_ANGLE		"toolTipTrackAngle"
#define	NAME_TTIP_GROUNDSPEED		"toolTipGroundSpeed"

#define	NAME_ADV_ID					"advisoryId"
#define	NAME_ADV_ALT				"advisoryAlt"
#define	NAME_ADV_RADALT				"advisoryRadAlt"
#define	NAME_ADV_DIST				"advisoryDist"
#define	NAME_ADV_BRG				"advisoryBrg"
#define	NAME_ADV_DELTA_ALT			"advisoryAltDiff"
#define	NAME_ADV_TRACK_ANGLE		"advisoryTrackAngle"
#define	NAME_ADV_GROUNDSPEED		"advisoryGroundSpeed"


#define	DRAW_NAME_RANGE				"Range"
#define	DRAW_NAME_HEADING			"Heading"
#define	DRAW_NAME_BRIGHTNESS		"Brightness"
#define	DRAW_NAME_OTHER_COL			"OtherColour"
#define	DRAW_NAME_PROXY_COL			"ProximityColour"
#define	DRAW_NAME_TA_COL			"TAColour"
#define	DRAW_NAME_RA_COL			"RAColour"
#define	DRAW_NAME_ANTIALIAS			"AntiAlias"
#define	DRAW_NAME_MAXRANGE			"MaxRange"
#define	DRAW_NAME_MAXNUMACT			"MaxNumAct"
#define	DRAW_NAME_CENTRE_X			"CenterX"
#define	DRAW_NAME_CENTRE_Y			"CenterY"
#define	DRAW_NAME_SYMBOL_SIZE		"SymbolSize"
#define	DRAW_NAME_INACT_DETAIL		"OtherDetail"
#define	DRAW_NAME_STRD_DETAIL		"ProximityDetail"
#define	DRAW_NAME_TA_DETAIL			"TADetail"
#define	DRAW_NAME_RA_DETAIL			"RADetail"
#define	DRAW_NAME_FIXED_RES			"FixedResolution"
#define	DRAW_NAME_PADSYMBOL			"PadSymbols"
#define	DRAW_NAME_SYMBOLFONT		"Font"
#define	DRAW_NAME_OTHER_RALT		"OtherMinRAlt"
#define	DRAW_NAME_OTHER_ABOVE		"OtherAboveAlt"
#define	DRAW_NAME_OTHER_BELOW		"OtherBelowAlt"
#define	DRAW_NAME_PROXIMITY_RANGE	"ProximityRange"
#define	DRAW_NAME_PROXIMITY_ABOVE	"ProximityAboveAlt"
#define	DRAW_NAME_PROXIMITY_BELOW	"ProximityBelowAlt"
#define	DRAW_NAME_MAXDISPNUMACT		"MaxDispNumAct"


#define	OLDINTERFACE_NAME			"TrafficRadar"
#define	OLDNAME_DRAW				"TCAS"
#define	OLDDRAW_NAME_INACT_COL		"InactiveColour"
#define	OLDDRAW_NAME_STRD_COL		"StandardColour"


#define	OLDNAME_RANGE				"TCASRange"
#define	OLDNAME_BRIGHT				"TCASBrightness"

//internal property ids for the above names
//don't need to be global, could be in .cpp, 
//but are here to show the relation of names and ids
#define	PROPERTY_RADAR					0
#define	PROPERTY_TCAS					1

#define	PROPERTY_RANGE					2
#define	PROPERTY_BRIGHT					3
#define	PROPERTY_XMOUSE					4
#define	PROPERTY_YMOUSE					5
#define	PROPERTY_TTIP					6
#define	PROPERTY_ADVISORY				7
#define	PROPERTY_TIM_SEP_TA				8
#define	PROPERTY_TIM_SEP_RA				9
#define	PROPERTY_DST_SEP_TA				10
#define	PROPERTY_DST_SEP_RA				11
#define	PROPERTY_ALT_SEP_TA				12
#define	PROPERTY_ALT_SEP_RA				13

#define	PROPERTY_TTIP_ID				14
#define	PROPERTY_TTIP_ALT				15
#define	PROPERTY_TTIP_DIST				16
#define	PROPERTY_TTIP_BRG				17
#define	PROPERTY_TTIP_DELTA_ALT			18
#define	PROPERTY_TTIP_TRACK_ANGLE		19
#define	PROPERTY_TTIP_GROUNDSPEED		20

#define	PROPERTY_ADV_ID					21
#define	PROPERTY_ADV_ALT				22
#define	PROPERTY_ADV_DIST				23
#define	PROPERTY_ADV_BRG				24
#define	PROPERTY_ADV_DELTA_ALT			25
#define	PROPERTY_ADV_TRACK_ANGLE		26
#define	PROPERTY_ADV_GROUNDSPEED		27

#define	PROPERTY_TTIP_RADALT			28
#define	PROPERTY_ADV_RADALT				29

#define	DRAW_PROPERTY_RANGE				0
#define	DRAW_PROPERTY_HEADING			1
#define	DRAW_PROPERTY_BRIGHTNESS		2
#define	DRAW_PROPERTY_OTHER_COL			3
#define	DRAW_PROPERTY_PROXY_COL			4
#define	DRAW_PROPERTY_TA_COL			5
#define	DRAW_PROPERTY_RA_COL			6
#define	DRAW_PROPERTY_ANTIALIAS			7
#define	DRAW_PROPERTY_MAXRANGE			8
#define	DRAW_PROPERTY_MAXNUMACT			9
#define	DRAW_PROPERTY_CENTRE_X			10
#define	DRAW_PROPERTY_CENTRE_Y			11
#define	DRAW_PROPERTY_SYMBOL_SIZE		12
#define	DRAW_PROPERTY_INACT_DETAIL		13
#define	DRAW_PROPERTY_STRD_DETAIL		14
#define	DRAW_PROPERTY_TA_DETAIL			15
#define	DRAW_PROPERTY_RA_DETAIL			16
#define	DRAW_PROPERTY_FIXED_RES			17
#define	DRAW_PROPERTY_PADSYMBOL			18
#define	DRAW_PROPERTY_SYMBOLFONT		19
#define	DRAW_PROPERTY_OTHER_RALT		20
#define	DRAW_PROPERTY_OTHER_ABOVE		21
#define	DRAW_PROPERTY_OTHER_BELOW		22
#define	DRAW_PROPERTY_PROXIMITY_RANGE	23
#define	DRAW_PROPERTY_PROXIMITY_ABOVE	24
#define	DRAW_PROPERTY_PROXIMITY_BELOW	25
#define	DRAW_PROPERTY_MAXDISPNUMACT		26





#define	TICK_MODULO			(18)




/*
* MyGaugeCDrawable implements the <CustomDraw...> method
* will be allocated at first acces to  <CustomDraw Name="xmlinterface:custom" ... >
* or on resizing/2D<->3D switching
* one example per displayed gauge
*/
class	MyAircraftCCallback;
class	MyGaugeCCallback;

class	MyGaugeCDrawable	:	public	IGaugeCDrawable	
{
	DECLARE_PANEL_CALLBACK_REFCOUNT(MyGaugeCDrawable)

protected:
	double			m_maxnum_act;
	double			m_max_range_nm;
	GdiPlusRadar	*m_radar;
	MyGaugeCCallback	*m_owner;
private:	
	int				m_oldbright;
	double			m_oldrange;

	
	BOOL			m_recalced;

	MODULE_VAR		m_tick18;


	virtual	void	InitRanges(		double	*pother_min_ralt,
									double	*pother_above_alt,
									double	*pother_below_alt,
									double	*pproxy_range,
									double	*pproxy_above_alt,
									double	*proxy_below_alt)=0;

	virtual	void	InitColours	(	int	*pother_colour,
									int	*pproxy_colour,
									int	*pta_colour,
									int	*pra_colour)=0;
	virtual	void	InitDetails	(	int	*pother_detail,
									int	*pproxy_detail,
									int	*pta_detail,
									int	*pra_detail)=0;

public:
	FLAGS32	GetFlags			(void);
	void	Update				(void);
	void	Show				(bool on);
	bool	Draw				(IGaugeCDrawableDrawParameters* pParameters, PIXPOINT size, HDC hdc, PIMAGE pImage);
	bool	SetupDraw			(PIXPOINT size, HDC hdc, PIMAGE pImage);
	bool	GetDraw				(IGaugeCDrawableDrawParameters* pParameters);



			MyGaugeCDrawable	(MyGaugeCCallback	*owner);
			~MyGaugeCDrawable	(void);
};

class	RadarCDrawable	:	public	MyGaugeCDrawable	
{
	private:
		void	InitRanges	(	double	*pother_min_ralt,
								double	*pother_above_alt,
								double	*pother_below_alt,
								double	*pproxy_range,
								double	*pproxy_above_alt,
								double	*proxy_below_alt);
		void	InitColours	(	int	*pother_colour,
								int	*pproxy_colour,
								int	*pta_colour,
								int	*pra_colour);
		void	InitDetails	(	int	*pother_detail,
								int	*pproxy_detail,
								int	*pta_detail,
								int	*pra_detail);

	public:	
				RadarCDrawable(MyGaugeCCallback	*owner);
};

class	TCASCDrawable	:	public	MyGaugeCDrawable	
{
	private:
		void	InitRanges	(	double	*pother_min_ralt,
								double	*pother_above_alt,
								double	*pother_below_alt,
								double	*pproxy_range,
								double	*pproxy_above_alt,
								double	*proxy_below_alt);
		void	InitColours	(	int	*pother_colour,
								int	*pproxy_colour,
								int	*pta_colour,
								int	*pra_colour);
		void	InitDetails	(	int	*pother_detail,
								int	*pproxy_detail,
								int	*pta_detail,
								int	*pra_detail);

	public:	
				TCASCDrawable(MyGaugeCCallback	*owner);
};


/*
* MyGaugeCCallback
* will be allocated at first acces to any C:xmlinterface:... variable or on resizing/2D<->3D switching
* one example per displayed gauge
*/

class	MyGaugeCCallback	:	public IGaugeCCallback 
{
private:

	char			m_tooltip[MOUSE_MAXIMUM_TOOLTIP_TEXT+1];
	
	tAircraftData	m_tooltip_data;
	tAircraftData	m_advisory_data;

	double			m_range;
	int				m_brightness;

	double			m_xposmouse;
	double			m_yposmouse;
	double			m_time_sep_ta;
	double			m_time_sep_ra;
	double			m_distance_sep_ta;
	double			m_distance_sep_ra;
	double			m_altitude_sep_ta;
	double			m_altitude_sep_ra;

	//caution! declares several vars and methods at once
	DECLARE_PANEL_CALLBACK_REFCOUNT(MyGaugeCCallback)
public:

	int		GetBrightness		(void);
	void	SetBrightness		(int value);
	
	double	GetRange			(void);
	void	SetRange			(double value);

	double	GetXPosMouse		(void);
	void	SetXPosMouse		(double value);
	double	GetYPosMouse		(void);
	void	SetYPosMouse		(double value);

	char*	GetTooltip			(void);

	void	SetTooltipData		(tAircraftData* value);
	void	SetAdvisoryData		(tAircraftData* value);

	double	GetTimeSepTA			(void);
	void	SetTimeSepTA			(double value);
	double	GetTimeSepRA			(void);
	void	SetTimeSepRA			(double value);
	double	GetDistanceSepTA		(void);
	void	SetDistanceSepTA		(double value);
	double	GetDistanceSepRA		(void);
	void	SetDistanceSepRA		(double value);
	double	GetAltitudeSepTA		(void);
	void	SetAltitudeSepTA		(double value);
	double	GetAltitudeSepRA		(void);
	void	SetAltitudeSepRA		(double value);


	IGaugeCCallback*	QueryInterface			(PCSTRINGZ pszInterface);
	void				Update					(void);

	bool				GetPropertyValue		(SINT32 id, FLOAT64* pValue);
	bool				GetPropertyValue		(SINT32 id, PCSTRINGZ* pszValue);
	bool				SetPropertyValue		(SINT32 id, FLOAT64 value);
	bool				SetPropertyValue		(SINT32 id, PCSTRINGZ szValue);
	IGaugeCDrawable*	CreateGaugeCDrawable	(SINT32 id, const IGaugeCDrawableCreateParameters* pParameters) ;


						MyGaugeCCallback		(MyAircraftCCallback *acft_owner);
						~MyGaugeCCallback		(void);
};

/*
* MyAircraftCCallback
* will be allocated at first acces to any C:xmlinterface:... variable
*/
class	MyAircraftCCallback	:	public IAircraftCCallback 
{
private:
	//caution! declares several vars and methods at once
	DECLARE_PANEL_CALLBACK_REFCOUNT(MyAircraftCCallback)

public:
	IAircraftCCallback* QueryInterface			(PCSTRINGZ pszInterface);
	IGaugeCCallback*	CreateGaugeCCallback	(void);
	void				Update					(void);

						MyAircraftCCallback		(void);
						~MyAircraftCCallback	(void);

};



/*
* MyPanelCCallback
* will be allocated at FS startup
*/
class	MyPanelCCallback	:	public IPanelCCallback 
{

private:
	BOOL				m_oldinterface;

	//caution! declares several vars and methods at once
	DECLARE_PANEL_CALLBACK_REFCOUNT(MyPanelCCallback)

public:
	IPanelCCallback*	QueryInterface			(PCSTRINGZ pszInterface);
	UINT32				GetVersion				(void);
	IAircraftCCallback*	CreateAircraftCCallback	(UINT32 ContainerID);
	bool				ConvertStringToProperty	(PCSTRINGZ keyword, SINT32* pID);
	bool				ConvertPropertyToString	(SINT32 id, PPCSTRINGZ pKeyword);
	bool				GetPropertyUnits		(SINT32 id, ENUM* pEnum);

						MyPanelCCallback		(BOOL	oldinterface=FALSE);
						~MyPanelCCallback		(void);
};

#endif	//XMLCCALLBACKS_H